﻿Imports System.Data.SqlClient
Imports System.Data
Imports System.Configuration
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindData()
        End If
    End Sub

    Private Sub BindData()
        Dim query As String = "SELECT top 10 * FROM Customers"
        Dim cmd As New SqlCommand(query)
        gvCustomers.DataSource = GetData(cmd)
        gvCustomers.DataBind()
    End Sub

    Private Function GetData(cmd As SqlCommand) As DataTable
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As New SqlConnection(strConnString)
            Using sda As New SqlDataAdapter()
                cmd.Connection = con
                sda.SelectCommand = cmd
                Using dt As New DataTable()
                    sda.Fill(dt)
                    Return dt
                End Using
            End Using
        End Using
    End Function

    Protected Sub EditCustomer(sender As Object, e As GridViewEditEventArgs)
        gvCustomers.EditIndex = e.NewEditIndex
        Me.BindData()
    End Sub

    Protected Sub CancelEdit(sender As Object, e As GridViewCancelEditEventArgs)
        gvCustomers.EditIndex = -1
        BindData()
    End Sub

    Protected Sub UpdateCustomer(sender As Object, e As GridViewUpdateEventArgs)
        Dim city As String = TryCast(gvCustomers.Rows(e.RowIndex).FindControl("ddlCities"), DropDownList).SelectedItem.Value
        Dim customerId As String = gvCustomers.DataKeys(e.RowIndex).Value.ToString()
        Dim strConnString As String = ConfigurationManager.ConnectionStrings("conString").ConnectionString
        Using con As New SqlConnection(strConnString)
            Dim query As String = "update customers set city = @city where customerId = @customerId"
            Using cmd As New SqlCommand(query)
                cmd.Connection = con
                cmd.Parameters.AddWithValue("@city", city)
                cmd.Parameters.AddWithValue("@customerId", customerId)
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
                Response.Redirect(Request.Url.AbsoluteUri)
            End Using
        End Using
    End Sub

    Protected Sub RowDataBound(sender As Object, e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow AndAlso gvCustomers.EditIndex = e.Row.RowIndex Then
            Dim ddlCities As DropDownList = DirectCast(e.Row.FindControl("ddlCities"), DropDownList)
            Dim query As String = "select distinct city from customers"
            Dim cmd As New SqlCommand(query)
            ddlCities.DataSource = GetData(cmd)
            ddlCities.DataTextField = "city"
            ddlCities.DataValueField = "city"
            ddlCities.DataBind()
            ddlCities.Items.FindByValue(TryCast(e.Row.FindControl("lblCity"), Label).Text).Selected = True
        End If
    End Sub

End Class
